<?php
namespace codemania\core;
/**
 * CodeMania Framework
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @license http://codemania.ru/license.html
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2012, CodeMania Team
 * @link  http://codemania.ru/
 */
defined('CM_ROOT') or exit('Заперт доступа!');

class Cookie {
    static public $_salt = false;
    static public $_path = '/';
    static public $_domain;
    static public $_secure = false;
    static public $_httponly = false;
    static public function get($name) {
        if (isset($_COOKIE[(string)$name])) {
            return base_64_decode($_COOKIE[$name]);
        }
        return false;
    }
    static public function set($name, $value, $expire) {
        $value = base_64_encode($value);
        setcookie((string)$name, (string)$value, time() + (int)$expire,
            self::$_path, self::$_domain, self::$_secure, self::$_httponly);
    }
    static public function delete($name) {
        if (isset($_COOKIE[(string)$name])) {
            unset($_COOKIE[$name]);
            setcookie($name, null, time() - 3600,
                self::$_path, self::$_domain, self::$_secure, self::$_httponly);
            return true;
        }
        return false;
    }
}