<?php
namespace codemania\core;
/**
 * CodeMania Framework
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2014, CodeMania Team
 * @link  http://codemania.ru
 * @license http://codemania.ru/license.html
 */
defined('CM_ROOT') or exit('Запрет доступа!');
/**
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @license http://codemania.ru/license.html
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2014, CodeMania Team
 * @link  http://guide.codemania.ru/class_Request.html
 */
class Request extends Route {
    /**
     * Директория контроллеров приложений
     * @const APPPATH
     */
    const APPPATH = 'application\classes\controllers\\';
    /**
     * Дериктория модулей 
     * @MODPATH
     */
    const MODPATH = 'application\modules\\';
    /**
     * Конструктор класса
     */
    public function __construct() {
        // Иницилизируем конструктор родительского класса 
        // и передаем ему URI
        parent::__construct($this->_detect_uri());
    }
    /**
     * Вычисляет строку URI запроса
     * @return string Обработанная строка запроса
     */
    private function _detect_uri() {
        // Проверяем наличие запроса после имени скрипта
            if (isset($_SERVER['PATH_INFO']) && !empty($_SERVER['PATH_INFO'])) {
                $uri = $_SERVER['PATH_INFO'];
                // Или берем из URI
            } elseif (isset($_SERVER['REQUEST_URI'])) {
                // Вырезаем строку запроса
                $ex = explode('?', $_SERVER['REQUEST_URI']);
                $uri = $ex[0];
                // Если пререданно имя скрипта то вырезаем его 
                if (stripos($uri, $_SERVER['SCRIPT_NAME']) === 0) {
                    $uri = substr($uri, strlen($_SERVER['SCRIPT_NAME']));
                }
            }
            // Убираем слеш "/" из начала и конца строки и декодируем ее
            return rawurldecode(trim($uri, '/'));
    }
    /**
     * 
     */
    public function body() {
        if ( ! $this->_get_controller_app()) {
            if ( ! $this->_get_default_controller()) {
                
            }
        } 
    }
    private function _get_controller_app($controller, $method) {
        $path = self::APPPATH . ucfirst($controller) .'_Controller';
        if (file_exists(CM_ROOT . $path.'.php') && @class_exists($path)) {
            if (method_exists($path, $method)) {
                return (new $path)->$method();
            }
        }
        return false;
    }
    private function _get_default_controller() {
        $path = self::APPPATH . self::$_default .'_Controller';
        $path2 = self::MODPATH . self::$_default .'/'. self::$_default .'_Controller';
        if (file_exists(CM_ROOT . $path.'.php') && @class_exists($path)) {
            if (method_exists($path, 'index')) {
                return (new $path)->index();
            }
        } elseif (file_exists(CM_ROOT . $path2.'.php') && @class_exists($path2)) {
            if (method_exists($path2, 'index')) {
                return (new $path2)->index();
            }
        }
        return false;
    }
}