<?php
namespace codemania\core;
/**
 * CodeMania Framework
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @license http://codemania.ru/license.html
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2014, CodeMania Team
 * @link  http://codemania.ru/
 */
defined('CM_ROOT') or exit('Заперт доступа!');
/**
 * Singelton
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @license http://codemania.ru/license.html
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2014, CodeMania Team
 * @link  http://guide.codemania.ru/class_Singelton.html
 */
abstract class Singleton {
    /**
     * Обьект наследуемого класса
     */
    static protected $_instance = false;
    /**
     * Возвращает обьект наследуемого класса
     */
    static public function instance() {
        // В PHP версии ниже 5.3.0 работать не будет
        Core::check_php_version('5.3.0');
        // Если Singelton еще не был обьявлен
        if (self::$_instance === false) {
            // Передаем имя дочернего класса в переменную 
            $instance_class = get_called_class();
            // Передаем обьект доернего класса 
            self::$_instance = new $instance_class();
        }
        // Передаем обьект класса
        return self::$_instance;
    }
    /**
     * Запрещает клонировать Singelton
     * @throws \LogicException
     */
    public final function __clone() {
        // Вызов функции выбрасывает исключение
        throw new \LogicException('Невозможно клонировать Singelton!');
    }
}