<?php
namespace codemania\library\database\drivers; 
/**
 * CodeMania Framework
 * 
 * @author CodeMania Team <team@codemania.ru>
 * @license http://codemania.ru/license.html
 * @package CodeMania
 * @version 1.0.0
 * @copyright (c) 2012, CodeMania Team
 * @link  http://codemania.ru/
 */
defined('CM_ROOT') or exit('Заперт доступа!');

class MySQLiDriver extends \mysqli {
    private $_result;
    private $_link = null;
    public function __construct($dsn) {
        extract(explode(':', $dsn));
        $this->_link = parent::__construct($host, $user, $password, $database, $port, $socket);
        if (mysqli_connect_errno()) {
            throw new \codemania\library\database\DataBaseException(
                    printf('Ошибка подключения к базе данных: %s', mysqli_connect_error()));
        }
    }
    public function query($query, array $param) {
        $stmt = $this->prepare((string)$query);
        $stmt->bind_param($this->_prepare_param_str($param), $param);
        $this->_result = $stmt->execute();
        $stmt->close();
        return $this->_result;
    }
    public function multi_query($query) {
        $this->_result = $this->multi_query($query);
        $this->_result->free();
        return $this->_result;
    }
    public function num_rows($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        return $this->_result->num_rows;
    }
    public function get_one_result($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        $result = $this->_result->fetch_array();
        return $result[0];
    }
    public function fetch_array($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        return $this->_result->fetch_array();
    }
    public function fetch_assoc($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        return $this->_result->fetch_array();
    }
    public function fetch_object($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        return $this->_result->fetch_object();
    }
    public function fetch_row($query = false, array $param = null) {
        if ($query) {
            $this->query($query, $param);
        }
        return $this->_result->fetch_row();
    }
    private function _prepare_param_str($param) {
        if (is_array($param)) {
            foreach ($param as $value) {
                $str .= gettype($value);
            }
            return $str;
        }
        return gettype($str);
    }
}